const keys = require('./ZHKeysMap');

let platform = 'linux';

if (process.platform === 'win32') {
  platform = 'windows';
}

if (process.platform === 'darwin') {
  platform = 'macOS';
}

const platformKeys = {};

Object.keys(keys).forEach(key => {
  const possibleKey = keys[key][platform];
  let platformKey = platformKeys[possibleKey];

  if (!platformKey) {
    platformKeys[possibleKey] = platformKey = {};
  }

  if (possibleKey === '*') {
    if (platformKey.keys) {
      platformKey.keys.push(key);
    }
    else {
      platformKey.keys = [key];
      platformKey.code = possibleKey;
      delete platformKey.key;
    }
  }
  else {
    platformKey.code = keys[key][platform];
    platformKey.key = key;
    platformKey.keys = [key];
  }
});

const keycode = keyname => {
  const key = keys[keyname];

  if (!key) {
    return `Keyname ${keyname} not found`;
  }

  const platformKey = key[platform];

  return platformKey === '*' ? 0 : platformKey;
};

module.exports.keyname = keycode => keycode === 0 ? platformKeys['*'] : platformKeys[keycode];
module.exports.keycode = keycode;
